"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitClient = void 0;
var simple_git_1 = require("simple-git");
var GitClient = /** @class */ (function () {
    function GitClient() {
        this.git = simple_git_1.default();
    }
    GitClient.prototype.tags = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remotes, tagsResponse, _i, remotes_1, remote, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.git.getRemotes()];
                    case 1:
                        remotes = (_c.sent()).map(function (r) { return r.name; });
                        tagsResponse = {};
                        _i = 0, remotes_1 = remotes;
                        _c.label = 2;
                    case 2:
                        if (!(_i < remotes_1.length)) return [3 /*break*/, 5];
                        remote = remotes_1[_i];
                        _a = tagsResponse;
                        _b = remote;
                        return [4 /*yield*/, this.git.listRemote(['--tags', remote])];
                    case 3:
                        _a[_b] = (_c.sent())
                            .split('\n')
                            .filter(function (line) { return line.trim(); })
                            .map(function (line) { return line.split('refs/tags/'); })
                            .filter(function (_a) {
                            var tagName = _a[1];
                            return tagName;
                        })
                            .map(function (_a) {
                            var tagName = _a[1];
                            return tagName;
                        })
                            .filter(function (name) { return name.indexOf('^{}') === -1; });
                        _c.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/, tagsResponse];
                }
            });
        });
    };
    GitClient.prototype.branch = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.git.branch()];
                    case 1: return [2 /*return*/, (_a.sent()).all
                            .filter(function (name) { return name.indexOf('remotes') === 0; })
                            .map(function (name) { return name.substr(8); })
                            .map(function (name) { return name.split(/\/(.+)/); })
                            .reduce(function (obj, _a) {
                            var _b;
                            var remote = _a[0], branchName = _a[1];
                            return (__assign(__assign({}, obj), (_b = {}, _b[remote] = __spreadArrays((obj[remote] || []), [branchName]), _b)));
                        }, {})];
                }
            });
        });
    };
    GitClient.prototype.removeObject = function (remote, item) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.git.push(remote, item, ['--delete'])];
            });
        });
    };
    return GitClient;
}());
exports.GitClient = GitClient;
//# sourceMappingURL=GitClient.js.map